<div id="body" class="container-fluid">
  <h6 class="mb-1">CPE Order Details</h6>
  <h6 class="text-danger" *ngIf="locked">{{ lblError }}</h6>
  <form [formGroup]="form" novalidate>
    <mat-accordion>
      <mat-expansion-panel [expanded]="true" class="mb-3">
        <mat-expansion-panel-header collapsedHeight="inherit" expandedHeight="inherit" class="card-header py-2 px-3">
          <mat-panel-title><h6>General</h6></mat-panel-title>
        </mat-expansion-panel-header>
        <app-equipment-review [group]="form.controls.equipmentReview" [parent]="this" *ngIf="isEquipmentReviewDataLoaded"></app-equipment-review>

        <app-material-requisition [group]="form.controls.materialRequisition" [parent]="this" *ngIf="isMatReqDataLoaded"></app-material-requisition>

        <app-equipment-receipt [group]="form.controls.equipmentReceipt" [parent]="this" *ngIf="isEquipmentReceiptDataLoaded"></app-equipment-receipt>

        <app-tech-assignment [group]="form.controls.techAssignment" [parent]="this" *ngIf="isTechAssignmentDataLoaded"></app-tech-assignment>

        <app-order-completion [group]="form.controls.orderCompletion" [parent]="this" *ngIf="isOrderCompletionDataLoaded"></app-order-completion>

        <!-- Return To Sales -->
        <mat-accordion *ngIf="isRTSLoaded">
          <mat-expansion-panel [expanded]="true" class="mb-3">
            <mat-expansion-panel-header collapsedHeight="inherit" expandedHeight="inherit" class="card-header py-2 px-3">
              <mat-panel-title><h6>Return To Sales</h6></mat-panel-title>
            </mat-expansion-panel-header>
            <div class="form-row">
              <div class="form-group form-group-sm row col-24">
                <label class="col-form-label col-24 col-lg-4">Jeopardy Code: </label>
                <div class="col-24 col-lg-20 pl-0 pl-lg-3">
                  <dx-select-box [items]="jeopardyCodeList" formControlName="jeopardyCode"
                                 displayExpr="cpeJprdyDes" valueExpr="cpeJprdyDes"
                                 placeholder="-- No Jeopardy Code --" searchMode="startswith"
                                 [searchEnabled]="true" [searchExpr]="['cpeJprdyDes']"
                                 (onSelectionChanged)="onJeopardyCodeChanged($event)"></dx-select-box>
                </div>
              </div>
            </div>
            <div class="form-row">
              <div class="form-group form-group-sm row col-24">
                <dx-check-box formControlName="emailPrimaryIPM"
                              text="{{emailPrimaryIPMText}}">
                </dx-check-box>
              </div>
            </div>
            <div class="form-row">
              <div class="form-group form-group-sm row col-24">
                <dx-check-box formControlName="emailPrimaryIS"
                              text="{{emailPrimaryISText}}">
                </dx-check-box>
              </div>
            </div>
          </mat-expansion-panel>
        </mat-accordion>

        <!-- Order Modification -->
        <mat-accordion *ngIf="isOrderModificationLoaded">
          <mat-expansion-panel [expanded]="true" class="mb-3">
            <mat-expansion-panel-header collapsedHeight="inherit" expandedHeight="inherit" class="card-header py-2 px-3">
              <mat-panel-title><h6>Order Modification</h6></mat-panel-title>
            </mat-expansion-panel-header>
            <div class="form-row">
              <div class="form-group form-group-sm row col-24 col-lg-12">
                <label class="col-form-label col-24 col-lg-8">Serving CPE CLLI: </label>
                <div class="col-24 col-lg-16 pl-0 pl-lg-3">
                  <input type="text" class="form-control form-control-sm" formControlName="servingCPEClli" />
                </div>
              </div>
            </div>
            <div class="form-row">
              <div class="form-group form-group-sm row col-24 col-lg-12">
                <label class="col-form-label col-24 col-lg-8">Assign Order to NTID: </label>
                <div class="col-24 col-lg-16 pl-0 pl-lg-3">
                  <input type="text" class="form-control form-control-sm" formControlName="assignedOrderToADID" />
                </div>
              </div>
            </div>
            <div class="form-row">
              <div class="form-group form-group-sm row col-24 col-lg-12">
                <label class="col-form-label col-24 col-lg-8">Rework to Task: </label>
                <div class="col-24 col-lg-16 pl-0 pl-lg-3">
                  <dx-select-box [items]="tasksList" formControlName="tasks"
                                 displayExpr="taskNme" valueExpr="taskId" searchMode="startswith"
                                 [searchEnabled]="true" [searchExpr]="['taskNme']"
                                 (onSelectionChanged)="onReworkToTaskChanged($event)"></dx-select-box>
                </div>
              </div>
            </div>
            <div class="form-row">
              <div class="form-group form-group-sm row col-24">
                <dx-radio-group [items]="chkOrderModificationList"
                                layout="horizontal"
                                (onValueChanged)="onChkOrderModificationChanged($event)">
                </dx-radio-group>
              </div>
            </div>
          </mat-expansion-panel>
        </mat-accordion>

        <!-- Re-Assignment -->
        <mat-accordion *ngIf="isReAssignLoaded">
          <mat-expansion-panel [expanded]="true" class="mb-3">
            <mat-expansion-panel-header collapsedHeight="inherit" expandedHeight="inherit" class="card-header py-2 px-3">
              <mat-panel-title><h6>Re-Assignment</h6></mat-panel-title>
            </mat-expansion-panel-header>
            <div class="form-row">
              <div class="form-group form-group-sm row col-24">
                <label class="col-form-label col-24 col-lg-4">Assigned Tech: </label>
                <div class="col-24 col-lg-20 pl-0 pl-lg-3">
                  <dx-select-box [items]="reAssignedTechsList" formControlName="reAssignedTech"
                                 displayExpr="useR_CPE_TECH_NME" valueExpr="useR_CPE_TECH_NME"
                                 [value]="reAssignedTech" searchMode="startswith"
                                 [searchEnabled]="true" [searchExpr]="['useR_CPE_TECH_NME']"
                                 (onSelectionChanged)="onReAssignedTechChanged($event)"></dx-select-box>
                </div>
              </div>
            </div>
            <div class="form-row">
              <div class="form-group form-group-sm row col-24 col-lg-12">
                <label class="col-form-label col-24 col-lg-8">Dispatch Time</label>
                <div class="col-24 col-lg-16 pl-0 pl-lg-3">
                  <dx-date-box type="datetime"
                               [acceptCustomValue]="false"
                               displayFormat="MM/dd/yyyy hh:mm aa"
                               width="100%"
                               [useMaskBehavior]="true"
                               formControlName="reDispatchTime"
                               [value]="reDispatchTime">
                  </dx-date-box>
                </div>
              </div>
            </div>
            <div class="form-row">
              <div class="form-group form-group-sm row col-24 col-lg-12">
                <label class="col-form-label col-24 col-lg-8">Event ID: </label>
                <div class="col-24 col-lg-16 pl-0 pl-lg-3">
                  <input type="text" class="form-control form-control-sm" formControlName="reEventId" [value]="reEventId" />
                </div>
              </div>
            </div>
          </mat-expansion-panel>
        </mat-accordion>

        <div class="form-row">
          <div class="form-group form-group-sm row col-24">
            <label class="col-form-label col-24 col-lg-2">Notes: </label>
            <div class="col-24 col-lg-22 pl-0 pl-lg-3">
              <textarea rows="5" class="form-control form-control-sm" formControlName="notes"></textarea>
            </div>
          </div>
        </div>

        <div class="form-row text mt-2">
          <div class="form-group form-group-sm form-group-sm col-12 col-md-4 col-lg-3" *ngIf="isMatReqDataLoaded">
            <button type="button" class="btn btn-sm btn-primary btn-block" (click)="btnSendOnlyMatReq_Click()" [disabled]="locked">
              Send Only
            </button>
          </div>
          <div class="form-group form-group-sm form-group-sm col-12 col-md-4 col-lg-3" *ngIf="isMatReqDataLoaded">
            <button type="button" class="btn btn-sm btn-primary btn-block" (click)="btnSendCompleteMatReq_Click()" [disabled]="locked">
              Send & Complete
            </button>
          </div>

          <div class="form-group form-group-sm form-group-sm col-12 col-md-4 col-lg-4" *ngIf="isEquipmentReceiptDataLoaded">
            <button type="button" class="btn btn-sm btn-primary btn-block" (click)="btnInsertDateWaitSCM_Click()" [disabled]="locked">
              Insert Date Wait SCM
            </button>
          </div>
          <div class="form-group form-group-sm form-group-sm col-12 col-md-4 col-lg-4" *ngIf="isEquipmentReceiptDataLoaded">
            <button type="button" class="btn btn-sm btn-primary btn-block" (click)="btnRemoveDateWaitSCM_Click()" [disabled]="locked">
              Remove Date Wait SCM
            </button>
          </div>
          <div class="form-group form-group-sm form-group-sm col-12 col-md-4 col-lg-3" *ngIf="isEquipmentReceiptDataLoaded">
            <button type="button" class="btn btn-sm btn-primary btn-block" (click)="btnNotifySCMOnly_Click()" [disabled]="locked">
              Notify SCM Only
            </button>
          </div>
          <div class="form-group form-group-sm form-group-sm col-12 col-md-4 col-lg-5" *ngIf="isEquipmentReceiptDataLoaded">
            <button type="button" class="btn btn-sm btn-primary btn-block" (click)="btnCompleteTaskNotifySCM_Click()" [disabled]="locked">
              Complete Task & Notify To SCM
            </button>
          </div>

          <div class="form-group form-group-sm form-group-sm col-12 col-md-4 col-lg-3" *ngIf="isReAssignLoaded">
            <button type="button" class="btn btn-sm btn-primary btn-block" (click)="btnCompleteTaskNotifySCM_Click()" [disabled]="locked">
              Reassignment
            </button>
          </div>
          <div class="form-group form-group-sm form-group-sm col-12 col-md-4 col-lg-3" *ngIf="isTechAssignmentDataLoaded">
            <button type="button" class="btn btn-sm btn-primary btn-block" (click)="btnTechAssign_Click()" [disabled]="locked">
              Assign
            </button>
          </div>
          <div class="form-group form-group-sm form-group-sm col-12 col-md-4 col-lg-3" *ngIf="displaySaveCommentsButton">
            <button type="button" class="btn btn-sm btn-primary btn-block" (click)="btnSaveComments_Click()" [disabled]="locked">
              Save Comments
            </button>
          </div>

          <!--<div class="form-group form-group-sm form-group-sm col-12 col-md-4 col-lg-4" *ngIf="displayOrderCompletionButtons">
    <button type="button" class="btn btn-sm btn-primary btn-block" (click)="btnCompleteSelectedItemsOnly_Click()" [disabled]="locked">
      Complete Selected Items Only
    </button>
  </div>-->
          <div class="form-group form-group-sm form-group-sm col-12 col-md-4 col-lg-5" *ngIf="displayOrderCompletionButtons">
            <button type="button" class="btn btn-sm btn-primary btn-block" (click)="btnCompleteEntireOrder_Click()" [disabled]="locked">
              Complete Entire Order
            </button>
          </div>
          <div class="form-group form-group-sm form-group-sm col-12 col-md-4 col-lg-3" *ngIf="isRTSLoaded">
            <button type="button" class="btn btn-sm btn-primary btn-block" (click)="btnRTS_Click()" [disabled]="locked">
              Return to Sales
            </button>
          </div>
          <div class="form-group form-group-sm form-group-sm col-12 col-md-4 col-lg-4" *ngIf="isOrderModificationLoaded">
            <button type="button" class="btn btn-sm btn-primary btn-block" (click)="btnOrderModification_Click()" [disabled]="locked">
              Order Modification
            </button>
          </div>
          <div class="form-group form-group-sm form-group-sm col-12 col-md-4 col-lg-3">
            <button type="button" class="btn btn-sm btn-secondary btn-block" (click)="btnCancel_Click()">
              Close Order
            </button>
          </div>
        </div>
      </mat-expansion-panel>
    </mat-accordion>

    <!--M5 # Details-->
    <mat-accordion>
      <mat-expansion-panel [expanded]="true" class="mb-2">
        <mat-expansion-panel-header collapsedHeight="inherit" expandedHeight="inherit" class="card-header py-2 px-3">
          <mat-panel-title><h6>M5 # Details</h6></mat-panel-title>
        </mat-expansion-panel-header>
        <dx-data-grid [dataSource]="m5DetailList"
                      [wordWrapEnabled]="true" [rowAlternationEnabled]="true"
                      [showBorders]="true" [columnAutoWidth]="true">
          <dxo-sorting mode="multiple"></dxo-sorting>
          <dxo-column-fixing [enabled]="true"></dxo-column-fixing>
          <dxo-scrolling mode="standard" useNative="false"></dxo-scrolling>

          <dxi-column dataField="ftn" caption="M5 #" dataType="string" cellTemplate="m5LinkTemplate"></dxi-column>
          <dxi-column dataField="custNme" caption="Customer Name" dataType="string"></dxi-column>
          <dxi-column dataField="ordrTypeDes" caption="Order Type" dataType="string"></dxi-column>
          <dxi-column dataField="ordrSubTypeDes" caption="Order Sub Type" dataType="string"></dxi-column>
          <dxi-column dataField="prodTypeDes" caption="Product Type" dataType="string"></dxi-column>
          <dxi-column dataField="ordrStusDes" caption="Order Status" dataType="string"></dxi-column>
          <dxi-column dataField="pendingTasks" caption="Pending Tasks" dataType="string"></dxi-column>
          <div *dxTemplate="let cell of 'm5LinkTemplate'">
            <a href="#" (click)="onM5Clicked($event, cell.data)">{{ cell.text }}</a>
          </div>
        </dx-data-grid>
        <br />
        <div *ngIf="fsaDetails.isShown">
          <app-m5-details [parent]="this"></app-m5-details>
        </div>
      </mat-expansion-panel>
    </mat-accordion>

    <!--<mat-accordion>
      <mat-expansion-panel [expanded]="true" class="mb-3">
        <mat-expansion-panel-header collapsedHeight="inherit" expandedHeight="inherit" class="card-header py-2 px-3">
          <mat-panel-title><h6>M5 # Detail</h6></mat-panel-title>
        </mat-expansion-panel-header>
        <app-m5-details [parent]="this"></app-m5-details>
      </mat-expansion-panel>
    </mat-accordion>-->
    <!--CCD History-->
    <mat-accordion>
      <mat-expansion-panel [expanded]="true" class="mb-3">
        <mat-expansion-panel-header collapsedHeight="inherit" expandedHeight="inherit" class="card-header py-2 px-3">
          <mat-panel-title><h6>CCD History</h6></mat-panel-title>
        </mat-expansion-panel-header>
        <dx-data-grid class="mb-3" [dataSource]="ccdList"
                      [wordWrapEnabled]="true" [rowAlternationEnabled]="true"
                      [showBorders]="true" [columnAutoWidth]="true">
          <dxo-sorting mode="multiple"></dxo-sorting>
          <dxo-column-fixing [enabled]="true"></dxo-column-fixing>
          <dxo-scrolling mode="standard" useNative="false"></dxo-scrolling>

          <dxi-column dataField="ccdOld" caption="Old CCD" dataType="datetime" cellTemplate="oldCcdDtTemplate"></dxi-column>
          <div *dxTemplate="let cell of 'oldCcdDtTemplate'">
            <span class="d-block">bl{{ cell.text | date: 'MM/dd/yyyy' }}</span>
          </div>
          <dxi-column dataField="ccdNew" caption="New CCD" dataType="datetime" cellTemplate="newCcdDtTemplate"></dxi-column>
          <div *dxTemplate="let cell of 'newCcdDtTemplate'">
            <span class="d-block">{{ cell.text | date: 'MM/dd/yyyy' }}</span>
          </div>
          <!--<dxi-column dataField="vndrSent" caption="Sent to Vendor" dataType="datetime" cellTemplate="sentToVndrDtTemplate"></dxi-column>
          <div *dxTemplate="let cell of 'sentToVndrDtTemplate'">
            <span class="d-block">{{ cell.text | date: 'MM/dd/yyyy' }}</span>
          </div>
          <dxi-column dataField="vndrAck" caption="ACK by Vendor" dataType="datetime" cellTemplate="ackByVndrDtTemplate"></dxi-column>
          <div *dxTemplate="let cell of 'ackByVndrDtTemplate'">
            <span class="d-block">{{ cell.text | date: 'MM/dd/yyyy' }}</span>
          </div>-->
          ta
          <dxi-column dataField="reasonPipeSV" caption="Reasons" dataType="string"></dxi-column>
          <dxi-column dataField="note" caption="Note" dataType="string"></dxi-column>
          <dxi-column dataField="createdByDspNme" caption="Changed By" dataType="string"></dxi-column>
          <dxi-column dataField="createdDateTime" caption="Change Date" dataType="datetime" cellTemplate="creatDtTemplate"></dxi-column>
          <div *dxTemplate="let cell of 'creatDtTemplate'">
            <span class="d-block">{{ cell.text | date: 'MM/dd/yyyy hh:mm aa' }}</span>
          </div>
        </dx-data-grid>
      </mat-expansion-panel>
    </mat-accordion>

    <!--Notes-->
    <mat-accordion>
      <mat-expansion-panel [expanded]="true" class="mb-3">
        <mat-expansion-panel-header collapsedHeight="inherit" expandedHeight="inherit" class="card-header py-2 px-3">
          <mat-panel-title><h6>M5 # Notes</h6><br /><div class="form-group form-group-sm row col-24 col-lg-12"><label>{{noteInfo}}</label></div></mat-panel-title>
        </mat-expansion-panel-header>
        <dx-data-grid class="mb-3" [dataSource]="noteList"
                      [wordWrapEnabled]="true" [rowAlternationEnabled]="true"
                      [showBorders]="true" [columnAutoWidth]="true">
          <dxo-sorting mode="multiple"></dxo-sorting>
          <dxo-column-fixing [enabled]="true"></dxo-column-fixing>
          <dxo-scrolling mode="standard" useNative="false"></dxo-scrolling>
          <dxo-paging [pageSize]="10"></dxo-paging>

          <dxi-column dataField="nteTypeDes" caption="Note Type" dataType="string"></dxi-column>
          <dxi-column dataField="nteTxt" caption="Note" dataType="string"></dxi-column>
          <dxi-column dataField="creatByUserFullName" caption="Created By" dataType="string"></dxi-column>
          <dxi-column dataField="creatDt" caption="Created Date" dataType="datetime" cellTemplate="dateTimeTemplate"></dxi-column>
          <div *dxTemplate="let cell of 'dateTimeTemplate'">
            <span class="d-block">{{ cell.text | date: 'MM/dd/yyyy' }}</span>
            <span class="d-block">{{ cell.text | date: 'hh:mm aa' }}</span>
          </div>
        </dx-data-grid>
      </mat-expansion-panel>
    </mat-accordion>
  </form>
</div>


<dx-speed-dial-action icon="collapse"
                      label="Collapse all panels"
                      [index]="1"
                      (onClick)="onCollapseClicked()">
</dx-speed-dial-action>
